#ifndef __DOWNLOAD_THREAD_H__
#define __DOWNLOAD_THREAD_H__

#include <glib-object.h>

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */


#define DOWNLOAD_THREAD(obj)            G_TYPE_CHECK_INSTANCE_CAST (obj,    \
                                            download_thread_get_type (),    \
                                            DownloadThread)
#define DOWNLOAD_THREAD_CLASS(klass)    G_TYPE_CHECK_CLASS_CAST (klass,     \
                                            download_thread_get_type (),    \
                                            DownloadThreadClass)
#define IS_DOWNLOAD_THREAD(obj)         G_TYPE_CHECK_INSTANCE_TYPE (obj,    \
                                            download_thread_get_type ())


typedef struct _DownloadThread       DownloadThread;
typedef struct _DownloadThreadClass  DownloadThreadClass;

struct _DownloadThread
{
    GObject object;

    /*< private >*/

	gint sock_fd;
	gint data_fd;
	gint file_fd;

	struct sockaddr_in *addr;
	struct timeval resolve_time;

	gulong bytes_start;
	gulong bytes_stop;
	guint bytes_done;

	gint redirect;

    gint stop;
};

struct _DownloadThreadClass
{
    GObjectClass parent_class;
};

GType           download_thread_get_type       (void);
DownloadThread* download_thread_new            ();


#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* __DOWNLOAD_THREAD_H__ */
