
GString *   dm_command_get_new          (guint project, const gchar *url);
void    dm_command_get_set_localpath    (GString *item, const gchar *localpath);
void    dm_command_get_set_stop         (GString *item, gboolean stop);
void    dm_command_get_set_recursive    (GString *item, guint recursive);
void    dm_command_get_set_speed        (GString *item, guint speed);
gint    dm_command_get                  (GString *item, guint fd);

gint    dm_command_download_start   (gint fd, guint project, guint download);
gint    dm_command_download_stop    (gint fd, guint project, guint download);
gint    dm_command_download_queue   (gint fd, guint project, guint download);
gint    dm_command_download_delete  (gint fd, guint project, guint download);

GString *   dm_command_project_create_new   (const gchar *name,
                                             const gchar *path);
void    dm_command_project_create_auto      (GString *item, guint setting);
void    dm_command_project_create_set_speed (GString *item, guint speed);
gint    dm_command_project_create   (GString *item, guint fd);

gint    dm_command_project_delete   (gint fd, guint project);
gint    dm_command_batchstatus      (gint fd, guint time, const char *batch);
gint    dm_command_batchprogress    (gint fd, guint time, const char *batch);
gint    dm_command_events           (gint fd, guint receive, const char *batch);
gint    dm_command_projects_events  (gint fd, guint receive);
gint    dm_command_auto             (gint fd, guint project, guint setting);
gint    dm_command_maxdownloads     (gint fd, guint project,
                                     guint maxdownloads);

enum dm_command_ids
{
    DM_COMMAND_NEW_ITEM = 100,
        DM_COMMAND_DOWNLOAD_URL,
        DM_COMMAND_DOWNLOAD_PATH,
        DM_COMMAND_DOWNLOAD_STOP,
        DM_COMMAND_DOWNLOAD_RECURSIVE,
        DM_COMMAND_DOWNLOAD_SPEED,
    DM_COMMAND_START_ITEM,
    DM_COMMAND_PAUSE_ITEM,
    DM_COMMAND_STOP_ITEM,
    DM_COMMAND_QUEUE_ITEM,
    DM_COMMAND_DONE_ITEM,
    DM_COMMAND_DELETE_ITEM,

    DM_COMMAND_BATCH_STATUS = 300,
    DM_COMMAND_BATCH_PROGRESS,

    DM_COMMAND_PROJECT_NEW = 400,
        DM_COMMAND_PROJECT_NAME,
        DM_COMMAND_PROJECT_PATH,
        DM_COMMAND_PROJECT_AUTO,
        DM_COMMAND_PROJECT_MAXDOWNLOADS,
        DM_COMMAND_PROJECT_SPEED,
    DM_COMMAND_PROJECT_DELETE,

    DM_COMMAND_CONFIG_NAME = 500,
    DM_COMMAND_CONFIG_EVENTS,
    DM_COMMAND_CONFIG_PROJECT_EVENTS,
    DM_COMMAND_CONFIG_BATCHSTATUS,
    DM_COMMAND_CONFIG_BATCHPROGRESS,

    DM_COMMAND_ERROR = 600,

    DM_COMMAND_SHUTDOWN = 900
};

enum dm_download_status
{
	STATUS_DONE = 0,

	STATUS_STOPPING,
	STATUS_STOPPED,
	STATUS_QUEUED,
	STATUS_INIT,
	STATUS_STARTING,
	STATUS_RESOLVING,
	STATUS_CONNECTING,
	STATUS_WAITING_DATA,
	STATUS_LOGIN,
	STATUS_TRANSFERING,

	ERROR_FIRST,

	ERROR_OPENING_FILE,
	ERROR_CREATING_SOCKET,
	ERROR_RESOLVING,
	ERROR_CONNECTING,
	ERROR_LOGIN,
	ERROR_GETTING_HEAD,
	ERROR_GETTING_DATA,
	ERROR_NOT_COMPLETE,

	ERROR_LAST
};

const gchar *dm_download_status_string (enum dm_download_status status);
